#include <cstdio>

using namespace std;

/* veiformistr:
     
     2=sqr2
     4=sqr4
     8=sqr8
     C=sqr12
     T=tri
     :=end
     
 */
static void Generoi(const char *veif, int inivol,
	unsigned wavelen,
	double atkpow, int atklen,
	double decpow, int declen)
{
	unsigned ptr;
	double vol = inivol;
	unsigned maxtick=44100/60, ticker=0;
	
	enum { attack, decay, muu } vaihe = attack;
	
	for(unsigned tick=0; tick<44100*5; ++tick)
	{
		signed char pha=0, tre=2;
		
		char veifcode = *veif;
		
		switch(veifcode)
		{
			case 'T':
			{
	            static const signed char wave[32] =
    	        {0,1,2,3,4,5,6,7,7,6,5,4,3,2,1,0,
        	    0,-1,-2,-3,-4,-5,-6,-7,-7,-6,-5,-4,-3,-2,-1,0};
            	pha = wave[(ptr / 100000) & 31]*2;
            	break;
            }
			case 'C':
				tre += 4;
			case '8':
				tre += 4;
			case '4':
				tre += 2;
            case '2':
				pha = (((ptr / 100000) & 15) < tre) ? 15 : -15;
		}
		
		int v = pha * (int)vol;
		
		v *= 30;
		
		putchar(((signed short)v) &255);
		putchar(((signed short)v) >> 8);
		
		ptr += 4000000 / wavelen;
		if(++ticker >= maxtick)
		{
			ticker -= maxtick;
			switch(vaihe)
			{
				case attack:
					if(atklen)
					{
						vol += atkpow;
						if(vol < 0)vol = 0;
						if(vol > 15)vol = 15;
						--atklen;
						break;
					}
					vaihe = decay;
				case decay:
					if(declen)
					{
						vol -= decpow;
						if(vol < 0)vol = 0;
						if(vol > 15)vol = 15;
						--declen;
						break;
					}
					vaihe = muu;
				case muu:
					break;
			}
			
			++veif;
			if(*veif == ':')
				--veif;
		}
	}
}

int main(void)
{
	Generoi("24:", 3, 
		240,
		1.50,  2,
		0.05, 84);
	return 0;
}
