#ifndef bqtSndHH
#define bqtSndHH

#include <vector>

struct SNDChannel
{
    enum chantype { undefined=0, sqr=1, rnd=2, tri=3, pcm=4 } type;
    unsigned char vol;     // 0..15 for any
    unsigned wavelen;      // 0..0x7FF for any
    unsigned char sample;  // or duty for sqr(2,4,8,12)
    unsigned age;          // Age of this row: most useful with pcm
    
    unsigned ins; // Filled later
};

class song
{
public:
    /* Parameters */
    unsigned rate;
    unsigned channelcount;
    /* Data */
    unsigned rownum;
    std::vector<SNDChannel> chanptr;
    std::vector<unsigned char> dpcmcache[256];

    song() : rate(0), channelcount(0), rownum(0), chanage(0)
    {
    }
    
private:
    /* Variables */
    unsigned chanage;
    
    void CheckRow();
public:
    void AddAge(unsigned n)
    {
        chanage += n;
    }
    
    const SNDChannel &ChanPtr(unsigned row, unsigned chan) const
    {
        return chanptr[row * channelcount + chan];
    }

    SNDChannel &GetChan(unsigned c)
    {
        CheckRow();
        SNDChannel &tmp = chanptr[rownum * channelcount + c];
        tmp.age = 0;
        return tmp;
    }
    
    /* Delete silence from the beginning of the songs */
    void DeleteSilence();
};

extern song ReadSND(const char *fn);

#endif
